/*
 * QU-PROLOG COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
 * 
 * Copyright 1993 by The University of Queensland, Queensland 4072 Australia
 * 
 * Permission to use, copy and distribute this software 
 * for any non-commercial purpose and without fee is hereby
 * granted, provided that the above copyright notice
 * and this permission notice and warranty
 * disclaimer appear in all copies and in supporting documentation, 
 * and that the name of The University of Queensland not be used in 
 * advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission.
 * 
 * Source code modifications are prohibited except where written agreement 
 * has been given in advance by The University of Queensland.
 * 
 * The University of Queensland disclaims all warranties with regard to this
 * software, including all implied warranties of merchantability and fitness.
 * In no event shall The University of Queensland be liable for any special,
 * indirect or consequential damages or any damages whatsoever resulting from
 * loss of use, data or profits, whether in an action of contract, negligence
 * or other tortious action, arising out of or in connection with the use or
 * performance of this software.
 *
 * dynamic - Special declarations for compiling the compiler.
 */

/*----------------------------------------------------------------------------
    Note: Since we are compiling the compiler with the compiler we need
    to turn off dynamics as they will clobber the procedure for the already
    existing predicate. Also we have to turn off asserts (and other database
    predicates) as they have already been added to the database.
----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------
suffix(N) :-
    The suffix added to a predicate name to differentiate it from it's
    parent.  Must be expressed in this form to avoid resetting the value
    of "suffix", when the compiler executes queries of the form ":- Goal".
----------------------------------------------------------------------------*/
:- clause(suffix(_N), true) ; assert(suffix(0)).
